
function twiddle_gen(p)
   
for t=1:log2(p.N)-1
    Twiddle_Table(1,t) = 2^(t+1);
end

% ROMf[^
for m=1:size(Twiddle_Table,2)
  [W_r, W_ex_r, W_i, W_ex_i] = twiddle_gen_calc(Twiddle_Table(1,m), p.Wordlength);
  st_num = log2(p.N) - m;
  
  file_name = sprintf('../verilog/twiddle_ST%d_W_r.txt',st_num);
  fid = fopen(file_name,'w');
  for k=1:size(W_r,2)
      fprintf(fid,'%s\n', dec2hex(W_r(1,k)));
  end
  fclose(fid);
  
  file_name = sprintf('../verilog/twiddle_ST%d_W_i.txt',st_num);
  fid = fopen(file_name,'w');
  for k=1:size(W_i,2)
      fprintf(fid,'%s\n', dec2hex(W_i(1,k)));
  end
  fclose(fid);

  file_name = sprintf('../verilog/twiddle_ST%d_W_ex_r.txt',st_num);
  fid = fopen(file_name,'w');
  for k=1:size(W_ex_r,2)
      fprintf(fid,'%s\n', dec2hex(W_ex_r(1,k)));
  end
  fclose(fid);
  
  file_name = sprintf('../verilog/twiddle_ST%d_W_ex_i.txt',st_num);
  fid = fopen(file_name,'w');
  for k=1:size(W_ex_i,2)
      fprintf(fid,'%s\n', dec2hex(W_ex_i(1,k)));
  end
  fclose(fid);
  
end

fid = fopen('../verilog/FFT_TWIDDLE.v','w');

% -- wb_[
fprintf(fid,'`ifdef SYNTOOL_OFF \n');
fprintf(fid,'`else \n');
fprintf(fid,'`include "definition.v" \n');
fprintf(fid,'`endif \n\n');

for m=1:size(Twiddle_Table,2)
    st_num = log2(p.N) - m;
    [W_r, W_ex_r, W_i, W_ex_i] = twiddle_gen_calc(Twiddle_Table(1,m), p.Wordlength);
    Num_W = size(W_r,2);
    fprintf(fid,'\n');
    fprintf(fid,'module TWIDDLE_ST%d(CLK, k, W_ex_r, W_r, W_ex_i, W_i);\n', st_num);
    fprintf(fid,'input  CLK;\n');
    if ((log2(Twiddle_Table(1,m))-2)==0)
        fprintf(fid,'input          k;\n');
    else
        fprintf(fid,'input  [%d:0]  k;\n', log2(Twiddle_Table(1,m))-2);
    end
    
    fprintf(fid,'output [`W-1:0]  W_r, W_i;\n');
    fprintf(fid,'output [1:0]   W_ex_r, W_ex_i;\n');
    fprintf(fid,'reg    [`W-1:0]  W_r, W_i;\n');
    fprintf(fid,'reg    [1:0]   W_ex_r, W_ex_i;\n');
    
    fprintf(fid,'reg    [`W-1:0]   Mem_W_r [%d:0];\n', Num_W-1);
    fprintf(fid,'reg    [`W-1:0]   Mem_W_i [%d:0];\n', Num_W-1);
    fprintf(fid,'reg    [1:0]   Mem_W_ex_r [%d:0];\n', Num_W-1);
    fprintf(fid,'reg    [1:0]   Mem_W_ex_i [%d:0];\n', Num_W-1);
    
    fprintf(fid,'initial begin\n'); 
    fprintf(fid,'$readmemh("twiddle_ST%d_W_r.txt", Mem_W_r);\n', st_num); 
    fprintf(fid,'$readmemh("twiddle_ST%d_W_i.txt", Mem_W_i);\n', st_num); 
    fprintf(fid,'$readmemh("twiddle_ST%d_W_ex_r.txt", Mem_W_ex_r);\n', st_num); 
    fprintf(fid,'$readmemh("twiddle_ST%d_W_ex_i.txt", Mem_W_ex_i);\n', st_num); 
    fprintf(fid,'end\n'); 
    fprintf(fid,'always@(posedge CLK)\n'); 
    fprintf(fid,'begin\n');
    fprintf(fid,'W_r <= Mem_W_r[k];\n');
    fprintf(fid,'W_i <= Mem_W_i[k];\n');
    fprintf(fid,'W_ex_r <= Mem_W_ex_r[k];\n');
    fprintf(fid,'W_ex_i <= Mem_W_ex_i[k];\n');
    fprintf(fid,'end\n');

    % -- tb_[
    fprintf(fid,'endmodule\n\n');
end

fclose(fid);
