`ifdef SYNTOOL_OFF 
`else 
`include "definition.v" 
`endif 


module FIFO_ST1(CLK, Fin_r, Fin_i, Fout_r, Fout_i);
input  CLK;
input  [`W-1:0]  Fin_r, Fin_i;
output [`W-1:0]  Fout_r, Fout_i;
reg    [`W-1:0] Fout_r, Fout_i;
reg    [`W-1:0] Fout_r0, Fout_i0;
reg    [`W-1:0] mem_r [4094:0];
reg    [`W-1:0] mem_i [4094:0];
reg    [11:0] k;
wire   [11:0] kr;
wire   we;
assign we = 1;
assign kr = (k==4094) ? 0 : k+1;
initial begin
 k=0;
end
always@(posedge CLK)
begin
        if (k==4094) k<=0; else k<=k+1; 
        if (we==1) begin 
            mem_r[k] = Fin_r;
            mem_i[k] = Fin_i;
        end 
        Fout_r0 <= mem_r[kr];
        Fout_i0 <= mem_i[kr];
        Fout_r <= Fout_r0;
        Fout_i <= Fout_i0;
end
endmodule


module FIFO_ST2(CLK, Fin_r, Fin_i, Fout_r, Fout_i);
input  CLK;
input  [`W-1:0]  Fin_r, Fin_i;
output [`W-1:0]  Fout_r, Fout_i;
reg    [`W-1:0] Fout_r, Fout_i;
reg    [`W-1:0] Fout_r0, Fout_i0;
reg    [`W-1:0] mem_r [2046:0];
reg    [`W-1:0] mem_i [2046:0];
reg    [10:0] k;
wire   [10:0] kr;
wire   we;
assign we = 1;
assign kr = (k==2046) ? 0 : k+1;
initial begin
 k=0;
end
always@(posedge CLK)
begin
        if (k==2046) k<=0; else k<=k+1; 
        if (we==1) begin 
            mem_r[k] = Fin_r;
            mem_i[k] = Fin_i;
        end 
        Fout_r0 <= mem_r[kr];
        Fout_i0 <= mem_i[kr];
        Fout_r <= Fout_r0;
        Fout_i <= Fout_i0;
end
endmodule


module FIFO_ST3(CLK, Fin_r, Fin_i, Fout_r, Fout_i);
input  CLK;
input  [`W-1:0]  Fin_r, Fin_i;
output [`W-1:0]  Fout_r, Fout_i;
reg    [`W-1:0] Fout_r, Fout_i;
reg    [`W-1:0] Fout_r0, Fout_i0;
reg    [`W-1:0] mem_r [1022:0];
reg    [`W-1:0] mem_i [1022:0];
reg    [9:0] k;
wire   [9:0] kr;
wire   we;
assign we = 1;
assign kr = (k==1022) ? 0 : k+1;
initial begin
 k=0;
end
always@(posedge CLK)
begin
        if (k==1022) k<=0; else k<=k+1; 
        if (we==1) begin 
            mem_r[k] = Fin_r;
            mem_i[k] = Fin_i;
        end 
        Fout_r0 <= mem_r[kr];
        Fout_i0 <= mem_i[kr];
        Fout_r <= Fout_r0;
        Fout_i <= Fout_i0;
end
endmodule


module FIFO_ST4(CLK, Fin_r, Fin_i, Fout_r, Fout_i);
input  CLK;
input  [`W-1:0]  Fin_r, Fin_i;
output [`W-1:0]  Fout_r, Fout_i;
reg    [`W-1:0] Fout_r, Fout_i;
reg    [`W-1:0] Fout_r0, Fout_i0;
reg    [`W-1:0] mem_r [510:0];
reg    [`W-1:0] mem_i [510:0];
reg    [8:0] k;
wire   [8:0] kr;
wire   we;
assign we = 1;
assign kr = (k==510) ? 0 : k+1;
initial begin
 k=0;
end
always@(posedge CLK)
begin
        if (k==510) k<=0; else k<=k+1; 
        if (we==1) begin 
            mem_r[k] = Fin_r;
            mem_i[k] = Fin_i;
        end 
        Fout_r0 <= mem_r[kr];
        Fout_i0 <= mem_i[kr];
        Fout_r <= Fout_r0;
        Fout_i <= Fout_i0;
end
endmodule


module FIFO_ST5(CLK, Fin_r, Fin_i, Fout_r, Fout_i);
input  CLK;
input  [`W-1:0]  Fin_r, Fin_i;
output [`W-1:0]  Fout_r, Fout_i;
reg    [`W-1:0] Fout_r, Fout_i;
reg    [`W-1:0] Fout_r0, Fout_i0;
reg    [`W-1:0] mem_r [254:0];
reg    [`W-1:0] mem_i [254:0];
reg    [7:0] k;
wire   [7:0] kr;
wire   we;
assign we = 1;
assign kr = (k==254) ? 0 : k+1;
initial begin
 k=0;
end
always@(posedge CLK)
begin
        if (k==254) k<=0; else k<=k+1; 
        if (we==1) begin 
            mem_r[k] = Fin_r;
            mem_i[k] = Fin_i;
        end 
        Fout_r0 <= mem_r[kr];
        Fout_i0 <= mem_i[kr];
        Fout_r <= Fout_r0;
        Fout_i <= Fout_i0;
end
endmodule


module FIFO_ST6(CLK, Fin_r, Fin_i, Fout_r, Fout_i);
input  CLK;
input  [`W-1:0]  Fin_r, Fin_i;
output [`W-1:0]  Fout_r, Fout_i;
reg    [`W-1:0] Fout_r, Fout_i;
reg    [`W-1:0] Fout_r0, Fout_i0;
reg    [`W-1:0] mem_r [126:0];
reg    [`W-1:0] mem_i [126:0];
reg    [6:0] k;
wire   [6:0] kr;
wire   we;
assign we = 1;
assign kr = (k==126) ? 0 : k+1;
initial begin
 k=0;
end
always@(posedge CLK)
begin
        if (k==126) k<=0; else k<=k+1; 
        if (we==1) begin 
            mem_r[k] = Fin_r;
            mem_i[k] = Fin_i;
        end 
        Fout_r0 <= mem_r[kr];
        Fout_i0 <= mem_i[kr];
        Fout_r <= Fout_r0;
        Fout_i <= Fout_i0;
end
endmodule


module FIFO_ST7(CLK, Fin_r, Fin_i, Fout_r, Fout_i);
input  CLK;
input  [`W-1:0]  Fin_r, Fin_i;
output [`W-1:0]  Fout_r, Fout_i;
reg    [`W-1:0] Fout_r, Fout_i;
reg    [`W-1:0] Fout_r0, Fout_i0;
reg    [`W-1:0] mem_r [62:0];
reg    [`W-1:0] mem_i [62:0];
reg    [5:0] k;
wire   [5:0] kr;
wire   we;
assign we = 1;
assign kr = (k==62) ? 0 : k+1;
initial begin
 k=0;
end
always@(posedge CLK)
begin
        if (k==62) k<=0; else k<=k+1; 
        if (we==1) begin 
            mem_r[k] = Fin_r;
            mem_i[k] = Fin_i;
        end 
        Fout_r0 <= mem_r[kr];
        Fout_i0 <= mem_i[kr];
        Fout_r <= Fout_r0;
        Fout_i <= Fout_i0;
end
endmodule


module FIFO_ST8(CLK, Fin_r, Fin_i, Fout_r, Fout_i);
input  CLK;
input  [`W-1:0]  Fin_r, Fin_i;
output [`W-1:0]  Fout_r, Fout_i;
reg    [`W-1:0] Fout_r, Fout_i;
reg    [`W-1:0] Fout_r0, Fout_i0;
reg    [`W-1:0] mem_r [30:0];
reg    [`W-1:0] mem_i [30:0];
reg    [4:0] k;
wire   [4:0] kr;
wire   we;
assign we = 1;
assign kr = (k==30) ? 0 : k+1;
initial begin
 k=0;
end
always@(posedge CLK)
begin
        if (k==30) k<=0; else k<=k+1; 
        if (we==1) begin 
            mem_r[k] = Fin_r;
            mem_i[k] = Fin_i;
        end 
        Fout_r0 <= mem_r[kr];
        Fout_i0 <= mem_i[kr];
        Fout_r <= Fout_r0;
        Fout_i <= Fout_i0;
end
endmodule


module FIFO_ST9(CLK, Fin_r, Fin_i, Fout_r, Fout_i);
input  CLK;
input  [`W-1:0]  Fin_r, Fin_i;
output [`W-1:0]  Fout_r, Fout_i;
reg    [`W-1:0] Fout_r, Fout_i;
reg    [`W-1:0] Fout_r0, Fout_i0;
reg    [`W-1:0] mem_r [14:0];
reg    [`W-1:0] mem_i [14:0];
reg    [3:0] k;
wire   [3:0] kr;
wire   we;
assign we = 1;
assign kr = (k==14) ? 0 : k+1;
initial begin
 k=0;
end
always@(posedge CLK)
begin
        if (k==14) k<=0; else k<=k+1; 
        if (we==1) begin 
            mem_r[k] = Fin_r;
            mem_i[k] = Fin_i;
        end 
        Fout_r0 <= mem_r[kr];
        Fout_i0 <= mem_i[kr];
        Fout_r <= Fout_r0;
        Fout_i <= Fout_i0;
end
endmodule


module FIFO_ST10(CLK, Fin_r, Fin_i, Fout_r, Fout_i);
input  CLK;
input  [`W-1:0]  Fin_r, Fin_i;
output [`W-1:0]  Fout_r, Fout_i;
reg    [`W-1:0] Fout_r, Fout_i;
reg    [`W-1:0] Fout_r0, Fout_i0;
reg    [`W-1:0] mem_r [6:0];
reg    [`W-1:0] mem_i [6:0];
reg    [2:0] k;
wire   [2:0] kr;
wire   we;
assign we = 1;
assign kr = (k==6) ? 0 : k+1;
initial begin
 k=0;
end
always@(posedge CLK)
begin
        if (k==6) k<=0; else k<=k+1; 
        if (we==1) begin 
            mem_r[k] = Fin_r;
            mem_i[k] = Fin_i;
        end 
        Fout_r0 <= mem_r[kr];
        Fout_i0 <= mem_i[kr];
        Fout_r <= Fout_r0;
        Fout_i <= Fout_i0;
end
endmodule


module FIFO_ST11(CLK, Fin_r, Fin_i, Fout_r, Fout_i);
input  CLK;
input  [`W-1:0]  Fin_r, Fin_i;
output [`W-1:0]  Fout_r, Fout_i;
reg    [`W-1:0] Fout_r, Fout_i;
reg    [`W-1:0] Fout_r0, Fout_i0;
reg    [`W-1:0] mem_r [2:0];
reg    [`W-1:0] mem_i [2:0];
reg    [1:0] k;
wire   [1:0] kr;
wire   we;
assign we = 1;
assign kr = (k==2) ? 0 : k+1;
initial begin
 k=0;
end
always@(posedge CLK)
begin
        if (k==2) k<=0; else k<=k+1; 
        if (we==1) begin 
            mem_r[k] = Fin_r;
            mem_i[k] = Fin_i;
        end 
        Fout_r0 <= mem_r[kr];
        Fout_i0 <= mem_i[kr];
        Fout_r <= Fout_r0;
        Fout_i <= Fout_i0;
end
endmodule


module FIFO_ST12(CLK, Fin_r, Fin_i, Fout_r, Fout_i);
input  CLK;
input  [`W-1:0]  Fin_r, Fin_i;
output [`W-1:0]  Fout_r, Fout_i;
reg [`W-1:0]  Fout_r, Fout_i;
reg    [31:0] F0;
always@(posedge CLK)
begin
F0[31:0] <= {Fin_r, Fin_i};
Fout_r <= F0[31:16];
Fout_i <= F0[15:0];
end
endmodule


module FIFO_ST13(CLK, Fin_r, Fin_i, Fout_r, Fout_i);
input  CLK;
input  [`W-1:0]  Fin_r, Fin_i;
output [`W-1:0]  Fout_r, Fout_i;
reg [`W-1:0]  Fout_r, Fout_i;
always@(posedge CLK)
begin
Fout_r <= Fin_r;
Fout_i <= Fin_i;
end
endmodule

