`ifdef SYNTOOL_OFF 
`else 
`include "definition.v" 
`endif 


module TWIDDLE_ST12(CLK, k, W_ex_r, W_r, W_ex_i, W_i);
input  CLK;
input          k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]  W_r, W_i;
reg    [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]   Mem_W_r [1:0];
reg    [`W-1:0]   Mem_W_i [1:0];
reg    [1:0]   Mem_W_ex_r [1:0];
reg    [1:0]   Mem_W_ex_i [1:0];
initial begin
$readmemh("twiddle_ST12_W_r.txt", Mem_W_r);
$readmemh("twiddle_ST12_W_i.txt", Mem_W_i);
$readmemh("twiddle_ST12_W_ex_r.txt", Mem_W_ex_r);
$readmemh("twiddle_ST12_W_ex_i.txt", Mem_W_ex_i);
end
always@(posedge CLK)
begin
W_r <= Mem_W_r[k];
W_i <= Mem_W_i[k];
W_ex_r <= Mem_W_ex_r[k];
W_ex_i <= Mem_W_ex_i[k];
end
endmodule


module TWIDDLE_ST11(CLK, k, W_ex_r, W_r, W_ex_i, W_i);
input  CLK;
input  [1:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]  W_r, W_i;
reg    [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]   Mem_W_r [3:0];
reg    [`W-1:0]   Mem_W_i [3:0];
reg    [1:0]   Mem_W_ex_r [3:0];
reg    [1:0]   Mem_W_ex_i [3:0];
initial begin
$readmemh("twiddle_ST11_W_r.txt", Mem_W_r);
$readmemh("twiddle_ST11_W_i.txt", Mem_W_i);
$readmemh("twiddle_ST11_W_ex_r.txt", Mem_W_ex_r);
$readmemh("twiddle_ST11_W_ex_i.txt", Mem_W_ex_i);
end
always@(posedge CLK)
begin
W_r <= Mem_W_r[k];
W_i <= Mem_W_i[k];
W_ex_r <= Mem_W_ex_r[k];
W_ex_i <= Mem_W_ex_i[k];
end
endmodule


module TWIDDLE_ST10(CLK, k, W_ex_r, W_r, W_ex_i, W_i);
input  CLK;
input  [2:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]  W_r, W_i;
reg    [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]   Mem_W_r [7:0];
reg    [`W-1:0]   Mem_W_i [7:0];
reg    [1:0]   Mem_W_ex_r [7:0];
reg    [1:0]   Mem_W_ex_i [7:0];
initial begin
$readmemh("twiddle_ST10_W_r.txt", Mem_W_r);
$readmemh("twiddle_ST10_W_i.txt", Mem_W_i);
$readmemh("twiddle_ST10_W_ex_r.txt", Mem_W_ex_r);
$readmemh("twiddle_ST10_W_ex_i.txt", Mem_W_ex_i);
end
always@(posedge CLK)
begin
W_r <= Mem_W_r[k];
W_i <= Mem_W_i[k];
W_ex_r <= Mem_W_ex_r[k];
W_ex_i <= Mem_W_ex_i[k];
end
endmodule


module TWIDDLE_ST9(CLK, k, W_ex_r, W_r, W_ex_i, W_i);
input  CLK;
input  [3:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]  W_r, W_i;
reg    [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]   Mem_W_r [15:0];
reg    [`W-1:0]   Mem_W_i [15:0];
reg    [1:0]   Mem_W_ex_r [15:0];
reg    [1:0]   Mem_W_ex_i [15:0];
initial begin
$readmemh("twiddle_ST9_W_r.txt", Mem_W_r);
$readmemh("twiddle_ST9_W_i.txt", Mem_W_i);
$readmemh("twiddle_ST9_W_ex_r.txt", Mem_W_ex_r);
$readmemh("twiddle_ST9_W_ex_i.txt", Mem_W_ex_i);
end
always@(posedge CLK)
begin
W_r <= Mem_W_r[k];
W_i <= Mem_W_i[k];
W_ex_r <= Mem_W_ex_r[k];
W_ex_i <= Mem_W_ex_i[k];
end
endmodule


module TWIDDLE_ST8(CLK, k, W_ex_r, W_r, W_ex_i, W_i);
input  CLK;
input  [4:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]  W_r, W_i;
reg    [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]   Mem_W_r [31:0];
reg    [`W-1:0]   Mem_W_i [31:0];
reg    [1:0]   Mem_W_ex_r [31:0];
reg    [1:0]   Mem_W_ex_i [31:0];
initial begin
$readmemh("twiddle_ST8_W_r.txt", Mem_W_r);
$readmemh("twiddle_ST8_W_i.txt", Mem_W_i);
$readmemh("twiddle_ST8_W_ex_r.txt", Mem_W_ex_r);
$readmemh("twiddle_ST8_W_ex_i.txt", Mem_W_ex_i);
end
always@(posedge CLK)
begin
W_r <= Mem_W_r[k];
W_i <= Mem_W_i[k];
W_ex_r <= Mem_W_ex_r[k];
W_ex_i <= Mem_W_ex_i[k];
end
endmodule


module TWIDDLE_ST7(CLK, k, W_ex_r, W_r, W_ex_i, W_i);
input  CLK;
input  [5:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]  W_r, W_i;
reg    [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]   Mem_W_r [63:0];
reg    [`W-1:0]   Mem_W_i [63:0];
reg    [1:0]   Mem_W_ex_r [63:0];
reg    [1:0]   Mem_W_ex_i [63:0];
initial begin
$readmemh("twiddle_ST7_W_r.txt", Mem_W_r);
$readmemh("twiddle_ST7_W_i.txt", Mem_W_i);
$readmemh("twiddle_ST7_W_ex_r.txt", Mem_W_ex_r);
$readmemh("twiddle_ST7_W_ex_i.txt", Mem_W_ex_i);
end
always@(posedge CLK)
begin
W_r <= Mem_W_r[k];
W_i <= Mem_W_i[k];
W_ex_r <= Mem_W_ex_r[k];
W_ex_i <= Mem_W_ex_i[k];
end
endmodule


module TWIDDLE_ST6(CLK, k, W_ex_r, W_r, W_ex_i, W_i);
input  CLK;
input  [6:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]  W_r, W_i;
reg    [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]   Mem_W_r [127:0];
reg    [`W-1:0]   Mem_W_i [127:0];
reg    [1:0]   Mem_W_ex_r [127:0];
reg    [1:0]   Mem_W_ex_i [127:0];
initial begin
$readmemh("twiddle_ST6_W_r.txt", Mem_W_r);
$readmemh("twiddle_ST6_W_i.txt", Mem_W_i);
$readmemh("twiddle_ST6_W_ex_r.txt", Mem_W_ex_r);
$readmemh("twiddle_ST6_W_ex_i.txt", Mem_W_ex_i);
end
always@(posedge CLK)
begin
W_r <= Mem_W_r[k];
W_i <= Mem_W_i[k];
W_ex_r <= Mem_W_ex_r[k];
W_ex_i <= Mem_W_ex_i[k];
end
endmodule


module TWIDDLE_ST5(CLK, k, W_ex_r, W_r, W_ex_i, W_i);
input  CLK;
input  [7:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]  W_r, W_i;
reg    [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]   Mem_W_r [255:0];
reg    [`W-1:0]   Mem_W_i [255:0];
reg    [1:0]   Mem_W_ex_r [255:0];
reg    [1:0]   Mem_W_ex_i [255:0];
initial begin
$readmemh("twiddle_ST5_W_r.txt", Mem_W_r);
$readmemh("twiddle_ST5_W_i.txt", Mem_W_i);
$readmemh("twiddle_ST5_W_ex_r.txt", Mem_W_ex_r);
$readmemh("twiddle_ST5_W_ex_i.txt", Mem_W_ex_i);
end
always@(posedge CLK)
begin
W_r <= Mem_W_r[k];
W_i <= Mem_W_i[k];
W_ex_r <= Mem_W_ex_r[k];
W_ex_i <= Mem_W_ex_i[k];
end
endmodule


module TWIDDLE_ST4(CLK, k, W_ex_r, W_r, W_ex_i, W_i);
input  CLK;
input  [8:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]  W_r, W_i;
reg    [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]   Mem_W_r [511:0];
reg    [`W-1:0]   Mem_W_i [511:0];
reg    [1:0]   Mem_W_ex_r [511:0];
reg    [1:0]   Mem_W_ex_i [511:0];
initial begin
$readmemh("twiddle_ST4_W_r.txt", Mem_W_r);
$readmemh("twiddle_ST4_W_i.txt", Mem_W_i);
$readmemh("twiddle_ST4_W_ex_r.txt", Mem_W_ex_r);
$readmemh("twiddle_ST4_W_ex_i.txt", Mem_W_ex_i);
end
always@(posedge CLK)
begin
W_r <= Mem_W_r[k];
W_i <= Mem_W_i[k];
W_ex_r <= Mem_W_ex_r[k];
W_ex_i <= Mem_W_ex_i[k];
end
endmodule


module TWIDDLE_ST3(CLK, k, W_ex_r, W_r, W_ex_i, W_i);
input  CLK;
input  [9:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]  W_r, W_i;
reg    [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]   Mem_W_r [1023:0];
reg    [`W-1:0]   Mem_W_i [1023:0];
reg    [1:0]   Mem_W_ex_r [1023:0];
reg    [1:0]   Mem_W_ex_i [1023:0];
initial begin
$readmemh("twiddle_ST3_W_r.txt", Mem_W_r);
$readmemh("twiddle_ST3_W_i.txt", Mem_W_i);
$readmemh("twiddle_ST3_W_ex_r.txt", Mem_W_ex_r);
$readmemh("twiddle_ST3_W_ex_i.txt", Mem_W_ex_i);
end
always@(posedge CLK)
begin
W_r <= Mem_W_r[k];
W_i <= Mem_W_i[k];
W_ex_r <= Mem_W_ex_r[k];
W_ex_i <= Mem_W_ex_i[k];
end
endmodule


module TWIDDLE_ST2(CLK, k, W_ex_r, W_r, W_ex_i, W_i);
input  CLK;
input  [10:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]  W_r, W_i;
reg    [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]   Mem_W_r [2047:0];
reg    [`W-1:0]   Mem_W_i [2047:0];
reg    [1:0]   Mem_W_ex_r [2047:0];
reg    [1:0]   Mem_W_ex_i [2047:0];
initial begin
$readmemh("twiddle_ST2_W_r.txt", Mem_W_r);
$readmemh("twiddle_ST2_W_i.txt", Mem_W_i);
$readmemh("twiddle_ST2_W_ex_r.txt", Mem_W_ex_r);
$readmemh("twiddle_ST2_W_ex_i.txt", Mem_W_ex_i);
end
always@(posedge CLK)
begin
W_r <= Mem_W_r[k];
W_i <= Mem_W_i[k];
W_ex_r <= Mem_W_ex_r[k];
W_ex_i <= Mem_W_ex_i[k];
end
endmodule


module TWIDDLE_ST1(CLK, k, W_ex_r, W_r, W_ex_i, W_i);
input  CLK;
input  [11:0]  k;
output [`W-1:0]  W_r, W_i;
output [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]  W_r, W_i;
reg    [1:0]   W_ex_r, W_ex_i;
reg    [`W-1:0]   Mem_W_r [4095:0];
reg    [`W-1:0]   Mem_W_i [4095:0];
reg    [1:0]   Mem_W_ex_r [4095:0];
reg    [1:0]   Mem_W_ex_i [4095:0];
initial begin
$readmemh("twiddle_ST1_W_r.txt", Mem_W_r);
$readmemh("twiddle_ST1_W_i.txt", Mem_W_i);
$readmemh("twiddle_ST1_W_ex_r.txt", Mem_W_ex_r);
$readmemh("twiddle_ST1_W_ex_i.txt", Mem_W_ex_i);
end
always@(posedge CLK)
begin
W_r <= Mem_W_r[k];
W_i <= Mem_W_i[k];
W_ex_r <= Mem_W_ex_r[k];
W_ex_i <= Mem_W_ex_i[k];
end
endmodule

